const _ = require('lodash')
const list1 = [
  {
    'id': '1239812149754368000',
    'department_name': '一公司',
    'parent_id': '0',
    '_add_level': '1',
    '_allowHandle': '0'
  },
  {
    'id': '1269815286401503401',
    'department_name': '1',
    'parent_id': '1239812149754368000',
    '_add_level': '2',
    '_allowHandle': '1'
  },
  {
    'id': '1278901072149254158',
    'department_name': '测试部门',
    'parent_id': '1269815286401503401',
    '_add_level': '2',
    '_allowHandle': '1'
  },
  {
    'id': '1278955607941091406',
    'department_name': '一车间',
    'parent_id': '1278901072149254158',
    '_add_level': '2',
    '_allowHandle': '1'
  },
  {
    'id': '1285749223762071618',
    'department_name': '2',
    'parent_id': '1239812149754368000',
    '_add_level': '2',
    '_allowHandle': '1'
  },
  {
    'id': '1289118482164781343',
    'department_name': '裁剪1',
    'parent_id': '1278901072149254158',
    '_add_level': '2',
    '_allowHandle': '1'
  }
]
const list2 = [
  {
    'id': '1270237816220192905',
    'name': '测试1',
    'parent_id': '1270237816220192906',
    'usable': true
  },
  {
    'id': '1270237816220192906',
    'name': '测试',
    'parent_id': '0',
    'usable': true
  },
  {
    'id': '1270237897702936587',
    'name': '参数1',
    'parent_id': '1270237897702936588',
    'usable': false
  },
  {
    'id': '1286536494933250079',
    'name': '测试2',
    'parent_id': '1270237816220192906',
    'usable': true
  },
  {
    'id': '1287558138334187692',
    'name': '测试3',
    'parent_id': '1270237816220192906',
    'usable': true
  },
  {
    'id': '1300307775553966176',
    'name': 'JJ0831',
    'parent_id': '1300307775553966176',
    'usable': true
  },
  {
    'id': '1300309829743710377',
    'name': 'test',
    'parent_id': '1270237816220192905',
    'usable': true
  }
]
class Tree {
  constructor() {}
  groupByParentId(data, parentId, primarykey) {
    const result = []
    const list = _.groupBy(data, parentId)
    for (const k in list) {
      const item = data.find(item => item[primarykey] === k)
      const obj = {
        id: k,
        name: item ? item.name : '',
        children: list[k]
      }
      result.push(obj)
    }
    return result
  }
  recursionChild(children, data, primarykey) {
    children.forEach(x => {
      const t = data.find(y => y[primarykey] === x[primarykey])
      if (t) {
        x.children = t.children
        const index = _.findIndex(data, function(o) { return o[primarykey] === t[primarykey] })
        data.splice(index, 1)
      } else {
        if (x.children) {
          this.recursionChild(x.children, data, primarykey)
        }
      }
    })
  }
  _recursionTree(data, primarykey) {
    let i = data.length
    while (i--) {
      const item = data[i]
      if (item) {
        if (item.children) {
          this.recursionChild(item.children, data, primarykey)
        }
      }
    }
  }
  transformTree(data, parentId, primarykey) {
    const groupList = this.groupByParentId(data, parentId, primarykey)
    this._recursionTree(groupList, primarykey)
    const list = []
    groupList.forEach(item => {
      list.push(...item.children)
    })
    return list
  }
}
// const t = new Tree()
// const d = t.transformTree(list2, 'parent_id', 'id')
// console.log(JSON.stringify(d))
export default Tree
